"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class AdditionalAnalysisPanel(ProtocolElement):
    """
    A panel of genes and the specific disease that it assesses
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "panel",
        "specificDisease",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_1 import reports as reports_6_7_0

        return {
            "panel": reports_6_7_0.GenePanel,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_1 import reports as reports_6_7_0

        return {
            "org.gel.models.report.avro.GenePanel": reports_6_7_0.GenePanel,
            "org.gel.models.report.avro.AdditionalAnalysisPanel": reports_6_7_0.AdditionalAnalysisPanel,
        }

    __slots__ = [
        "panel",
        "specificDisease",
    ]

    def __init__(
        self,
        panel,
        specificDisease,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_7_0.AdditionalAnalysisPanel model.

        :param panel:
        :type panel: GenePanel
        :param specificDisease:
        :type specificDisease: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.7.0"
